# coding: utf-8

"""
    Trackside Software TeamDB API v2.0

    This API enables you to access TeamDB data  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: support@trackside.fr
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from teamdbapi.configuration import Configuration


class IssueProject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'Id': 'str',
        'Name': 'str',
        'Description': 'str',
        'IssueIdFormat': 'str',
        'WorkflowId': 'str'
    }

    attribute_map = {
        'Id': 'Id',
        'Name': 'Name',
        'Description': 'Description',
        'IssueIdFormat': 'IssueIdFormat',
        'WorkflowId': 'WorkflowId'
    }

    def __init__(self, Id=None, Name=None, Description=None, IssueIdFormat=None, WorkflowId=None, _configuration=None):  # noqa: E501
        """IssueProject - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._Id = None
        self._Name = None
        self._Description = None
        self._IssueIdFormat = None
        self._WorkflowId = None
        self.discriminator = None

        self.Id = Id
        self.Name = Name
        if Description is not None:
            self.Description = Description
        self.IssueIdFormat = IssueIdFormat
        self.WorkflowId = WorkflowId

    @property
    def Id(self):
        """Gets the Id of this IssueProject.  # noqa: E501

        Unique identifier of the project  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new project  # noqa: E501

        :return: The Id of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._Id

    @Id.setter
    def Id(self, Id):
        """Sets the Id of this IssueProject.

        Unique identifier of the project  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new project  # noqa: E501

        :param Id: The Id of this IssueProject.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Id is None:
            raise ValueError("Invalid value for `Id`, must not be `None`")  # noqa: E501

        self._Id = Id

    @property
    def Name(self):
        """Gets the Name of this IssueProject.  # noqa: E501

        Name of the project  # noqa: E501

        :return: The Name of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._Name

    @Name.setter
    def Name(self, Name):
        """Sets the Name of this IssueProject.

        Name of the project  # noqa: E501

        :param Name: The Name of this IssueProject.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Name is None:
            raise ValueError("Invalid value for `Name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                Name is not None and len(Name) < 1):
            raise ValueError("Invalid value for `Name`, length must be greater than or equal to `1`")  # noqa: E501

        self._Name = Name

    @property
    def Description(self):
        """Gets the Description of this IssueProject.  # noqa: E501

        Description of the project  # noqa: E501

        :return: The Description of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._Description

    @Description.setter
    def Description(self, Description):
        """Sets the Description of this IssueProject.

        Description of the project  # noqa: E501

        :param Description: The Description of this IssueProject.  # noqa: E501
        :type: str
        """

        self._Description = Description

    @property
    def IssueIdFormat(self):
        """Gets the IssueIdFormat of this IssueProject.  # noqa: E501

        Project HumanId format  # noqa: E501

        :return: The IssueIdFormat of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._IssueIdFormat

    @IssueIdFormat.setter
    def IssueIdFormat(self, IssueIdFormat):
        """Sets the IssueIdFormat of this IssueProject.

        Project HumanId format  # noqa: E501

        :param IssueIdFormat: The IssueIdFormat of this IssueProject.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and IssueIdFormat is None:
            raise ValueError("Invalid value for `IssueIdFormat`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                IssueIdFormat is not None and len(IssueIdFormat) < 1):
            raise ValueError("Invalid value for `IssueIdFormat`, length must be greater than or equal to `1`")  # noqa: E501

        self._IssueIdFormat = IssueIdFormat

    @property
    def WorkflowId(self):
        """Gets the WorkflowId of this IssueProject.  # noqa: E501

        Unique identifier of the associated workflow  # noqa: E501

        :return: The WorkflowId of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._WorkflowId

    @WorkflowId.setter
    def WorkflowId(self, WorkflowId):
        """Sets the WorkflowId of this IssueProject.

        Unique identifier of the associated workflow  # noqa: E501

        :param WorkflowId: The WorkflowId of this IssueProject.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and WorkflowId is None:
            raise ValueError("Invalid value for `WorkflowId`, must not be `None`")  # noqa: E501

        self._WorkflowId = WorkflowId

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IssueProject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IssueProject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IssueProject):
            return True

        return self.to_dict() != other.to_dict()
