# coding: utf-8

"""
    Trackside Software TeamDB API v2.0

    This API enables you to access TeamDB data  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: support@trackside.fr
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from teamdbapi.configuration import Configuration


class IssueType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'Id': 'str',
        'Name': 'str',
        'Default': 'bool',
        'Obsolete': 'bool'
    }

    attribute_map = {
        'Id': 'Id',
        'Name': 'Name',
        'Default': 'Default',
        'Obsolete': 'Obsolete'
    }

    def __init__(self, Id=None, Name=None, Default=None, Obsolete=None, _configuration=None):  # noqa: E501
        """IssueType - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._Id = None
        self._Name = None
        self._Default = None
        self._Obsolete = None
        self.discriminator = None

        self.Id = Id
        self.Name = Name
        if Default is not None:
            self.Default = Default
        if Obsolete is not None:
            self.Obsolete = Obsolete

    @property
    def Id(self):
        """Gets the Id of this IssueType.  # noqa: E501

        The Id of the item.  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new issue list item  # noqa: E501

        :return: The Id of this IssueType.  # noqa: E501
        :rtype: str
        """
        return self._Id

    @Id.setter
    def Id(self, Id):
        """Sets the Id of this IssueType.

        The Id of the item.  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new issue list item  # noqa: E501

        :param Id: The Id of this IssueType.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Id is None:
            raise ValueError("Invalid value for `Id`, must not be `None`")  # noqa: E501

        self._Id = Id

    @property
    def Name(self):
        """Gets the Name of this IssueType.  # noqa: E501

        The name of the item.  # noqa: E501

        :return: The Name of this IssueType.  # noqa: E501
        :rtype: str
        """
        return self._Name

    @Name.setter
    def Name(self, Name):
        """Sets the Name of this IssueType.

        The name of the item.  # noqa: E501

        :param Name: The Name of this IssueType.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Name is None:
            raise ValueError("Invalid value for `Name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                Name is not None and len(Name) < 1):
            raise ValueError("Invalid value for `Name`, length must be greater than or equal to `1`")  # noqa: E501

        self._Name = Name

    @property
    def Default(self):
        """Gets the Default of this IssueType.  # noqa: E501

        Define whether the item is the default one or not.  # noqa: E501

        :return: The Default of this IssueType.  # noqa: E501
        :rtype: bool
        """
        return self._Default

    @Default.setter
    def Default(self, Default):
        """Sets the Default of this IssueType.

        Define whether the item is the default one or not.  # noqa: E501

        :param Default: The Default of this IssueType.  # noqa: E501
        :type: bool
        """

        self._Default = Default

    @property
    def Obsolete(self):
        """Gets the Obsolete of this IssueType.  # noqa: E501

        Define whether the item is obsolete or not.  # noqa: E501

        :return: The Obsolete of this IssueType.  # noqa: E501
        :rtype: bool
        """
        return self._Obsolete

    @Obsolete.setter
    def Obsolete(self, Obsolete):
        """Sets the Obsolete of this IssueType.

        Define whether the item is obsolete or not.  # noqa: E501

        :param Obsolete: The Obsolete of this IssueType.  # noqa: E501
        :type: bool
        """

        self._Obsolete = Obsolete

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IssueType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IssueType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IssueType):
            return True

        return self.to_dict() != other.to_dict()
