# coding: utf-8

"""
    Trackside Software TeamDB API v2.0

    This API enables you to access TeamDB data  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: support@trackside.fr
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from teamdbapi.configuration import Configuration


class Script(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'Id': 'str',
        'Name': 'str',
        'Path': 'str',
        'IsSharedScript': 'bool',
        'SharedScriptOwner': 'str',
        'RunInGuiThread': 'bool'
    }

    attribute_map = {
        'Id': 'Id',
        'Name': 'Name',
        'Path': 'Path',
        'IsSharedScript': 'IsSharedScript',
        'SharedScriptOwner': 'SharedScriptOwner',
        'RunInGuiThread': 'RunInGuiThread'
    }

    def __init__(self, Id=None, Name=None, Path=None, IsSharedScript=None, SharedScriptOwner=None, RunInGuiThread=None, _configuration=None):  # noqa: E501
        """Script - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._Id = None
        self._Name = None
        self._Path = None
        self._IsSharedScript = None
        self._SharedScriptOwner = None
        self._RunInGuiThread = None
        self.discriminator = None

        self.Id = Id
        self.Name = Name
        if Path is not None:
            self.Path = Path
        if IsSharedScript is not None:
            self.IsSharedScript = IsSharedScript
        if SharedScriptOwner is not None:
            self.SharedScriptOwner = SharedScriptOwner
        if RunInGuiThread is not None:
            self.RunInGuiThread = RunInGuiThread

    @property
    def Id(self):
        """Gets the Id of this Script.  # noqa: E501

        The unique script Id.  # noqa: E501

        :return: The Id of this Script.  # noqa: E501
        :rtype: str
        """
        return self._Id

    @Id.setter
    def Id(self, Id):
        """Sets the Id of this Script.

        The unique script Id.  # noqa: E501

        :param Id: The Id of this Script.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Id is None:
            raise ValueError("Invalid value for `Id`, must not be `None`")  # noqa: E501

        self._Id = Id

    @property
    def Name(self):
        """Gets the Name of this Script.  # noqa: E501

        The script name.  # noqa: E501

        :return: The Name of this Script.  # noqa: E501
        :rtype: str
        """
        return self._Name

    @Name.setter
    def Name(self, Name):
        """Sets the Name of this Script.

        The script name.  # noqa: E501

        :param Name: The Name of this Script.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and Name is None:
            raise ValueError("Invalid value for `Name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                Name is not None and len(Name) < 1):
            raise ValueError("Invalid value for `Name`, length must be greater than or equal to `1`")  # noqa: E501

        self._Name = Name

    @property
    def Path(self):
        """Gets the Path of this Script.  # noqa: E501

        The script file path.  The path must be described only by / or \\\\\\\\.  # noqa: E501

        :return: The Path of this Script.  # noqa: E501
        :rtype: str
        """
        return self._Path

    @Path.setter
    def Path(self, Path):
        """Sets the Path of this Script.

        The script file path.  The path must be described only by / or \\\\\\\\.  # noqa: E501

        :param Path: The Path of this Script.  # noqa: E501
        :type: str
        """

        self._Path = Path

    @property
    def IsSharedScript(self):
        """Gets the IsSharedScript of this Script.  # noqa: E501

        True if it is a shared script.  # noqa: E501

        :return: The IsSharedScript of this Script.  # noqa: E501
        :rtype: bool
        """
        return self._IsSharedScript

    @IsSharedScript.setter
    def IsSharedScript(self, IsSharedScript):
        """Sets the IsSharedScript of this Script.

        True if it is a shared script.  # noqa: E501

        :param IsSharedScript: The IsSharedScript of this Script.  # noqa: E501
        :type: bool
        """

        self._IsSharedScript = IsSharedScript

    @property
    def SharedScriptOwner(self):
        """Gets the SharedScriptOwner of this Script.  # noqa: E501

        The shared script owner name.  # noqa: E501

        :return: The SharedScriptOwner of this Script.  # noqa: E501
        :rtype: str
        """
        return self._SharedScriptOwner

    @SharedScriptOwner.setter
    def SharedScriptOwner(self, SharedScriptOwner):
        """Sets the SharedScriptOwner of this Script.

        The shared script owner name.  # noqa: E501

        :param SharedScriptOwner: The SharedScriptOwner of this Script.  # noqa: E501
        :type: str
        """

        self._SharedScriptOwner = SharedScriptOwner

    @property
    def RunInGuiThread(self):
        """Gets the RunInGuiThread of this Script.  # noqa: E501

        True if the script runs in the GUI thread.  # noqa: E501

        :return: The RunInGuiThread of this Script.  # noqa: E501
        :rtype: bool
        """
        return self._RunInGuiThread

    @RunInGuiThread.setter
    def RunInGuiThread(self, RunInGuiThread):
        """Sets the RunInGuiThread of this Script.

        True if the script runs in the GUI thread.  # noqa: E501

        :param RunInGuiThread: The RunInGuiThread of this Script.  # noqa: E501
        :type: bool
        """

        self._RunInGuiThread = RunInGuiThread

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Script, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Script):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Script):
            return True

        return self.to_dict() != other.to_dict()
